/* Main program for DUNGEON */

/* COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. */
/* ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED */
/* WRITTEN BY R. M. SUPNIK */
/* Translated from Fortran to C by Andrew Plotkin <erkyrath@netcom.com>
   on 10/4/98. */

/* 16-Aug-94     RMS     Version 3.2. */
/* 30-Jun-92     RMS     Changed file names to lower case. */
/* 29-Jun-92     RMS     Changed OUTCH to 6 for VAX, UNIX compatibility. */

#include "glk.h"
#include "miscfort.h"
#include "funcs.h"
#include "commons.h"

/* Initialized data */

struct misc_1_ misc_1 = {
        0, 0, 0, 0, 0, 0,
        {66, 67, 68, 69, 70, 71, 72, 65, 73},
        0, 0, 0, 0, 0, 0,
        3, 2, {"B"}
};

struct curxt_1_ curxt_1 = { {1, 2, 3, 3}, 0, 0, 0, 0, 0 };

struct screen_1_ screen_1 = { 0, 0, 0, 
            { 1024, 153, 5120, 154, 3072, 152, 7168, 151}, 
            { 151, 271, 3072, 152, 272, 7168, 153, 270, 5120, 154, 269, 1024}};

struct puzzle_1_ puzzle_1 = {
        { 1024, -8, 2048, -7, 3072, 1, 4096, 9, 5120, 8, 6144, 7, 7168, -1, 8192, -9 }, 
        { 269, -8, 270, 8, 271, 1, 272, -1 }, 
        {         1,  1,  1,  1,  1,  1,  1,  1,  
                1,  0, -1,  0,  0, -1,  0,  1,  
                1, -1,  0,  1,  0, -2,  0,  1,  
                1,  0,  0,  0,  0,  1,  0,  1,  
                1, -3,  0,  0, -1, -1,  0,  1,  
                1,  0,  0, -1,  0,  0,  0,  1,  
                1,  1,  1,  0,  0,  0,  1,  1,  
                1,  1,  1,  1,  1,  1,  1,  1  } };


/* Main program */ 
int dungeon_main(void)
{
    /* Local variables */
    integer i__, x;


/* Declarations */


/* Data statements for constant arrays */





/* DUNGEON, PAGE 2 */

/* 1) Initialize data structures */
/* 2) Initialize files */
/* 3) Play game */

    rmsg_1.mlnt = 0;
/* init array counters. */
    objcts_1.olnt = 0;
/* array limits are param */
    rooms_1.rlnt = 0;
    vill_1.vlnt = 0;
    advs_1.alnt = 0;
    cevent_1.clnt = 0;
    exits_1.xlnt = 1;
    oroom2_1.r2lnt = 0;

    play_1.ltshft = 10;
/* set up state variables */
    play_1.mxscor = play_1.ltshft;
    play_1.egscor = 0;
    play_1.egmxsc = 0;
    play_1.mxload = 100;
    play_1.rwscor = 0;
    play_1.deaths = 0;
    play_1.moves = 0;
    misc_1.pltime = 0;
    play_1.mungrm = 0;
    play_1.hs = 0;
    prsvec_1.prsa = 0;
/* clear parse vector. */
    prsvec_1.prsi = 0;
    prsvec_1.prso = 0;
    prsvec_1.prscon = 1;
    prssta_1.oflag = 0;
/* clear orphans. */
    prssta_1.oact = 0;
    prssta_1.oprep1 = 0;
    prssta_1.oobj1 = 0;
    prssta_1.oprep = 0;
    s_copy(prssta_1.oname, " ", 8L, 1L);
    prssta_1.oprep2 = 0;
    prssta_1.oobj2 = 0;
    prssta_1.bunlnt = 0;
/* clear bunch vector. */
    prssta_1.bunsub = 0;
    for (i__ = 1; i__ <= 10; ++i__) {
        prssta_1.bunvec[i__ - 1] = 0;
/* L100: */
    }
    hack_1.thfflg = FALSE_;
/* thief not introduced b */
    hack_1.thfact = TRUE_;
/* is active. */
    hack_1.swdact = FALSE_;
/* sword is inactive. */
    hack_1.swdsta = 0;

/* sword is off. */
    misc_1.mbase = 0;
/* init melee base. */
    misc_1.inpch = 5;
/* tty input */
    misc_1.outch = 6;
/* tty output. */
    misc_1.dbch = 2;
/* DUNGEON, PAGE 3 */

/* Init all arrays. */

/* data base. */
    for (i__ = 1; i__ <= 30; ++i__) {
/* clear clock events */
        cevent_1.cflag[i__ - 1] = FALSE_;
        cevent_1.ccncel[i__ - 1] = FALSE_;
        cevent_1.ctick[i__ - 1] = 0;
        cevent_1.cactio[i__ - 1] = 0;
/* L200: */
    }

/* clear flags. */
/* clear switches. */
    v_set(&findex_1, sizeof(struct findex_1_), 0);
    /*
    for (i__ = 1; i__ <= 56; ++i__) {
        flags[i__ - 1] = FALSE_;
    }
    for (i__ = 1; i__ <= 24; ++i__) {
        switch__[i__ - 1] = 0;
    }
    */

    findex_1.egyptf = TRUE_;
/* some start as true. */
    findex_1.cagetf = TRUE_;
    findex_1.mr1f = TRUE_;
    findex_1.mr2f = TRUE_;
    findex_1.follwf = TRUE_;
    findex_1.ormtch = 4;
/* number of matches. */
    findex_1.lcell = 1;
    findex_1.pnumb = 1;
    findex_1.mdir = 270;
    findex_1.mloc = 162;
    findex_1.cphere = 10;

    for (i__ = 1; i__ <= 20; ++i__) {
/* clear room 2 array. */
        oroom2_1.r2[i__ - 1] = 0;
        oroom2_1.o2[i__ - 1] = 0;
/* L500: */
    }

    for (i__ = 1; i__ <= 1000; ++i__) {
/* clear travel array. */
        exits_1.travel[i__ - 1] = 0;
/* L600: */
    }

    for (i__ = 1; i__ <= 4; ++i__) {
/* clear villains arrays. */
        vill_1.vopps[i__ - 1] = 0;
        vill_1.vprob[i__ - 1] = 0;
        vill_1.villns[i__ - 1] = 0;
        vill_1.vbest[i__ - 1] = 0;
        vill_1.vmelee[i__ - 1] = 0;
/* L700: */
    }
/* DUNGEON, PAGE 4 */

    for (i__ = 1; i__ <= 300; ++i__) {
/* clear object arrays. */
        objcts_1.odesc1[i__ - 1] = 0;
        objcts_1.odesc2[i__ - 1] = 0;
        objcts_1.odesco[i__ - 1] = 0;
        objcts_1.oread[i__ - 1] = 0;
        objcts_1.oactio[i__ - 1] = 0;
        objcts_1.oflag1[i__ - 1] = 0;
        objcts_1.oflag2[i__ - 1] = 0;
        objcts_1.ofval[i__ - 1] = 0;
        objcts_1.otval[i__ - 1] = 0;
        objcts_1.osize[i__ - 1] = 0;
        objcts_1.ocapac[i__ - 1] = 0;
        objcts_1.ocan[i__ - 1] = 0;
        objcts_1.oadv[i__ - 1] = 0;
        objcts_1.oroom[i__ - 1] = 0;
/* L800: */
    }

    rooms_1.rdesc2 = 0;
/* clear desc base ptr. */
    for (i__ = 1; i__ <= 200; ++i__) {
/* clear room arrays. */
        rooms_1.rdesc1[i__ - 1] = 0;
        rooms_1.ractio[i__ - 1] = 0;
        rooms_1.rflag[i__ - 1] = 0;
        rooms_1.rval[i__ - 1] = 0;
        rooms_1.rexit[i__ - 1] = 0;
/* L900: */
    }

    for (i__ = 1; i__ <= 1500; ++i__) {
/* clear message director */
        rmsg_1.rtext[i__ - 1] = 0;
/* L1000: */
    }

    for (i__ = 1; i__ <= 4; ++i__) {
/* clear adventurer's arr */
        advs_1.aroom[i__ - 1] = 0;
        advs_1.ascore[i__ - 1] = 0;
        advs_1.avehic[i__ - 1] = 0;
        advs_1.aobj[i__ - 1] = 0;
        advs_1.aactio[i__ - 1] = 0;
        advs_1.astren[i__ - 1] = 0;
        advs_1.aflag[i__ - 1] = 0;
/* L1100: */
    }

    misc_1.dbgflg = 0;
    misc_1.prsflg = 0;
    misc_1.gdtflg = 1;

    screen_1.fromdr = 0;
/* init scol goodies. */
    screen_1.scolrm = 0;
    screen_1.scolac = 0;

    if (initfl_(&x)) {
        game_();
    }
/* if init files, play ga */
    s_stop(" ", 1L);
/* done */
    return 0;
} /* MAIN__ */



/* TXCRYP - Subroutine to encrypt/decrypt text strings. */

/* This subroutine performs a reversible encryption on a text string. */
/* The purpose is not to protect the data base but to make it more */
/* difficult for the casual game user to read the data base file. */
/* It is located here, rather than in the SUBRoutine module, because */
/* it is used by both the game and the separate data base compiler. */

/* Subroutine */ int txcryp_(integer *r__, char *line, ftnlen line_len)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    integer i__, x;


    i__1 = i_len(line, line_len);
    for (i__ = 1; i__ <= i__1; ++i__) {
        x = (*r__ & 31) + i__;
        *(unsigned char *)&line[i__ - 1] = (char) (*(unsigned char *)&line[
                i__ - 1] ^ x);
/* L100: */
    }
    return 0;
} /* txcryp_ */


